package de.tudarmstadt.maki.simonstrator.api;

/**
 * A message that has some sort of disaster type with a priority.
 * 
 * @author Simon Luser
 *
 */
public interface MessageWithDisasterType extends Message {

	public static enum MessageDisasterType {
		Emergency(1), Warning(2), SearchFor(3), SimpleMsg(4);

		private int priority;

		private MessageDisasterType(int priority) {
			this.priority = priority;
		}

		public int getPriorityValue() {
			return priority;
		}
	}

	public MessageDisasterType getDisasterType();
}
