package de.tudarmstadt.maki.simonstrator.api.component.overlay;

import java.util.UUID;

import de.tudarmstadt.maki.simonstrator.api.Message;

/**
 * Base-Interface for Overlay Messages. Consider extending
 * {@link AbstractOverlayMessage}
 * 
 * @author Bjoern Richerzhagen, Julian Zobel
 * @version September 2018
 */
public interface OverlayMessage extends Message {

	/**
	 * The overlay contact of the intended receiver or null, if not specified.
	 * 
	 * @return
	 */
	public OverlayContact getReceiver();

	/**
	 * The overlay contact of the sender or null, if not specified.
	 * 
	 * @return
	 */
	public OverlayContact getSender();

	/**
	 * @return The message universally unique identifier
	 */
	default public UUID getUUID() {
		throw new UnsupportedOperationException();
	}

	default public boolean hasUUID() {
		return false;
	}

	/**
	 * @return The message creation timestamp
	 */
	default public long getTimestamp() {
		throw new UnsupportedOperationException();
	}

	default public boolean hasTimestamp() {
		return false;
	}
}
