/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


package de.tudarmstadt.maki.simonstrator.api.component.sensor.environment.data.properties;

import de.tudarmstadt.maki.simonstrator.api.component.sensor.location.Location;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkEdge;

/**
 * @author Bjoern Bueschke
 * @version 1.0 at 27.03.2018
 *
 */
public class RainProperty extends AbstractRoadProperty {

	private final boolean _rain;
	
	public RainProperty(Location pLocation, RoadNetworkEdge pEdge, boolean pRain) {
		super(pLocation, pEdge);
		_rain = pRain;
	}

	public boolean hasRain() {
		return _rain;
	}

	@Override
	public RoadProperty getDefaultProperty() {
		return new RainProperty(getLocation(), getEdge(), false);
	}

	@Override
	public Object getValue() {
		return hasRain();
	}

	@Override
	public RainProperty clone() {
		RainProperty property = new RainProperty(getLocation(), getEdge(), _rain);
		property.setDuration(getDuration());
		property.setDetectionDate(getDetectionDate());
		return property;
	}
}
