/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


package de.tudarmstadt.maki.simonstrator.api.component.sensor.environment.data.roadcondition;

import de.tudarmstadt.maki.simonstrator.api.component.sensor.environment.data.properties.AbstractRoadProperty;
import de.tudarmstadt.maki.simonstrator.api.component.sensor.environment.data.properties.RoadProperty;
import de.tudarmstadt.maki.simonstrator.api.component.sensor.location.Location;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkEdge;

/**
 * @author Tobias Meuser (tobias.meuser@kom.tu-darmstadt.de)
 * @version 1.0 at 27.02.2018
 *
 */
public class RoadConditionProperty extends AbstractRoadProperty {

	private RoadCondition _roadCondition;

	public RoadConditionProperty(Location pLocation, RoadNetworkEdge pEdge) {
		this(pLocation, pEdge, RoadCondition.DRY);
	}

	public RoadConditionProperty(Location pLocation, RoadNetworkEdge pEdge, RoadCondition pRoadCondition) {
		super(pLocation, pEdge);
		_roadCondition = pRoadCondition;
	}

	public RoadCondition getRoadCondition() {
		return _roadCondition;
	}

	public void setRoadCondition(RoadCondition pRoadCondition) {
		_roadCondition = pRoadCondition;
	}

	@Override
	public Object getValue() {
		return getRoadCondition();
	}

	@Override
	public RoadProperty getDefaultProperty() {
		return new RoadConditionProperty(getLocation(), getEdge(), RoadCondition.DRY);
	}

	@Override
	public RoadConditionProperty clone() {
		RoadConditionProperty property = new RoadConditionProperty(getLocation(), getEdge(), _roadCondition);
		property.setDuration(getDuration());
		property.setDetectionDate(getDetectionDate());
		return property;
	}

}
