/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


package de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.paths;

/**
 * @author Tobias Meuser (tobias.meuser@kom.tu-darmstadt.de)
 * @version 1.0 at 28.11.2017
 *
 */
public final class VehiclePathTrackerFactory {
	private static VehiclePathTracker VEHICLE_PATH_TRACKER;

	private static boolean _prediction = true;

	public static void setPrediction(boolean pPrediction) {
		_prediction = pPrediction;
		if (VEHICLE_PATH_TRACKER != null) {
			VEHICLE_PATH_TRACKER.setPrediction(pPrediction);
		}
	}

	public static VehiclePathTracker getVehiclePathTracker() {
		if (VEHICLE_PATH_TRACKER == null) {
			throw new AssertionError(
					"The class " + VehiclePathTracker.class + " needs to be initialized in your configuration file!");
		}
		return VEHICLE_PATH_TRACKER;
	}

	public static void registerVehiclePathTracker(VehiclePathTracker pTracker) {
		if (VEHICLE_PATH_TRACKER != null) {
			throw new AssertionError("The class " + VehiclePathTracker.class + " has already been registered!");
		}
		VEHICLE_PATH_TRACKER = pTracker;
		VEHICLE_PATH_TRACKER.setPrediction(_prediction);
	}
}
