/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.routing;

import java.util.List;

import de.tudarmstadt.maki.simonstrator.api.component.vehicular.information.RoadInformation;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkEdge;

public class LatestPossibleDijkstraAlgorithm extends DijkstraAlgorithm {

	protected double calculateAdditionalEdgeCosts(RoadNetworkEdge pEdge, List<RoadInformation> pInfo,
			double pCurrentPathLength, List<RoadNetworkEdge> pCurrentRouteList) {
		if (pInfo != null && pCurrentRouteList.size() > 0) {
			for (RoadInformation roadInformation : pInfo) {
				if (pCurrentRouteList.get(0).equals(roadInformation.getEdge())
						|| pCurrentRouteList.get(0).getAccessibleEdges().contains(roadInformation.getEdge())) {
					double additionalCostIfKnown = pEdge.calculateAdditionalCostIfKnown(roadInformation.getValue());
					return additionalCostIfKnown;
				}
			}
		}
		return 0d;
	}
}
