package de.tudarmstadt.maki.simonstrator.api.web.approach;

import java.util.HashMap;
import java.util.Map;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlID;

@XmlAccessorType(XmlAccessType.FIELD)
public class Approach {
    public enum ApproachType {
        OWN, BASELINE, REFERENCE;
    }

	@XmlID
    @XmlElement(name = "name")
    private String _name;

    @XmlElement(name = "type")
    private ApproachType _type = ApproachType.REFERENCE;

    @XmlElementWrapper(name = "variables")
    @XmlElement(name = "variables")
    private Map<String, String> _variables = new HashMap<>();

    public Approach() {
    }

    public Approach(String pName, ApproachType pType) {
        _name = pName;
        _type = pType;
    }

    public String getName() {
        return _name;
    }

    public Map<String, String> getVariables() {
        return _variables;
    }

    public void addVariable(String pKey, String pValue) {
        _variables.put(pKey, pValue);
    }

    public void setName(String pName) {
        _name = pName;
    }

    public ApproachType getType() {
        return _type;
    }

    public void setType(ApproachType pType) {
        _type = pType;

    }

    public void clearVariables() {
        _variables.clear();
    }
}
