package de.tudarmstadt.maki.simonstrator.api.web.options;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;

import de.tudarmstadt.maki.simonstrator.api.web.options.database.DatabaseOptions;
import de.tudarmstadt.maki.simonstrator.api.web.options.plotting.PlottingOptions;

@XmlAccessorType(XmlAccessType.FIELD)
public class WebRunnerOptions {
	@XmlElement(name = "runtime")
	private RuntimeOptions _runtime;

	@XmlElement(name = "database")
	private DatabaseOptions _database;

	@XmlElement(name = "plotting")
	private PlottingOptions _plotting;

	public RuntimeOptions getRuntime() {
		if (_runtime == null) {
			_runtime = new RuntimeOptions();
		}
		return _runtime;
	}

	public DatabaseOptions getDatabase() {
		if (_database == null) {
			_database = new DatabaseOptions();
		}
		return _database;
	}

	public PlottingOptions getPlotting() {
		if (_plotting == null) {
			_plotting = new PlottingOptions();
		}
		return _plotting;
	}

}
