package de.tudarmstadt.maki.simonstrator.api.web.parameter;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlID;

@XmlAccessorType(XmlAccessType.FIELD)
public class Parameter {
	@XmlID
    @XmlElement(name = "name")
    private String _name;

    @XmlElementWrapper(name = "values")
    @XmlElement(name = "value")
    private List<String> _values = new ArrayList<>();

	@XmlElement(name = "default")
    private int _defaultIndex;

    public Parameter() {
    }

    public Parameter(String pName) {
        _name = pName;
    }

    public String getName() {
        return _name;
    }

    public List<String> getValues() {
        return _values;
    }

    public void addValue(String pValue) {
        _values.add(pValue);
    }

    public void setName(String pName) {
        _name = pName;
    }

    public void clearValues() {
        _values.clear();
    }

    public void setDefault(int pDefaultIndex) {
        _defaultIndex = pDefaultIndex;
    }

    public int getDefaultIndex() {
        return _defaultIndex;
    }
}
